// eatmem.cpp

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

int main(int argc, char* argv[])
{
	// try to lock up to argv[1] pages
	if (argc != 2) {
		printf("Eatmem requires an argument: MB to lock.\n");
		return -1;
	}

	long mb = atoi(argv[1]);

	// tell the system we're going to do this bad thing...
	while (mb && !SetProcessWorkingSetSize(GetCurrentProcess(), mb * 1024 * 1024 + 262144, (long)mb * 1024 * 1024 + 262144)) {
		mb --;
		printf("Could not set process working set...Decremented to %d\n", mb);
	}

	if (!mb) return 0;

	const long mbsize = 0x100000;
	long membase = 0x10000000;

	for (long i = 0; i < mb; i++) {
		void *buf = GlobalAlloc(GMEM_FIXED, mbsize);

		if (!buf) {
			printf("Global alloc failed.\n");
			break;
		}

		// lock
		if (!VirtualLock(buf, mbsize)) {
			printf("Virtual lock failed.\n");
			break;
		}

		printf("%d...", i + 1);
		fflush(stdout);

		//membase += mbsize;
	}

	printf("\n\n%dMB allocated.\nPress a key to free memory and exit...\n", i);
	// note: process term unlocks pages, so we're sloppy about the rest
	_getch();

	return 0;
}

